#
# rpm spec file for Snare for Linux
#
Name: SnareLinux
Summary: Snare for Linux - audit subsystem control and distribution
Version: 2.1.0
Release: 1
License: GPL
Group: System Environment/Daemons
Packager: Leigh Purdie
URL: http://www.intersectalliance.com/

Source0: %{name}-%{version}.tar.gz

Requires: audit >= 2.0.0, audit-libs >= 2.0.0
BuildRequires: audit-libs-devel >= 2.0.0

Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The System iNtrusion Analysis and Reporting Environment (SNARE) agent for
Linux provides a event collection, filtering, control and remote distribution
cabability for the Linux operating system. Snare supports organisations
that need to meet national security policy guidelines such as NISPOM,
DCID/DIAM, SOX/Sarbanes Oxley, GLBA, CISP and BS7799.

%prep
zcat $RPM_SOURCE_DIR/%{name}-%{version}.tar.gz | tar -xvf -
# Filter unwanted Requires:
cat << \EOF > %{name}-req
#!/bin/sh
%{__perl_requires} $* | sed -e '/perl(Mcrypt)/d'
EOF

%define __perl_requires %{_builddir}/%{name}-req
chmod +x %{__perl_requires}

%build
cd %{name}-%{version}
%{__make} clean
%{__make}

%install
if [ ! %{buildroot} = "/" ]; then %{__rm} -rf %{buildroot}; fi
cd %{name}-%{version}
#%{__make} DESTDIR=%{buildroot} install
mkdir -p %{buildroot}/usr/sbin  %{buildroot}/etc %{buildroot}/usr/share/%{name}-%{version} %{buildroot}/etc/audit
cp Installer.sh %{buildroot}/usr/sbin/SnareInstaller.sh
cp SnareDispatcher.pl %{buildroot}/usr/sbin/SnareDispatcher
cp SnareDispatchHelper %{buildroot}/usr/sbin/SnareDispatchHelper
cp SnareWebServer.pl %{buildroot}/usr/sbin/SnareWebServer.pl
cp SnareTranslationTable %{buildroot}/usr/sbin/SnareTranslationTable
cp snare.conf %{buildroot}/etc/snare.conf
cp snare.pp %{buildroot}/usr/share/%{name}-%{version}/
#cp snare2.pp %{buildroot}/usr/share/%{name}-%{version}/

%post
if [ -f /usr/sbin/semodule ]; then
	/usr/sbin/semodule -i /usr/share/%{name}-%{version}/snare.pp > /dev/null
	#if the first module failed, try the second one
	#if [ "$?" -gt 0 ]; then
		#/usr/sbin/semodule -i /usr/share/%{name}-%{version}/snare2.pp > /dev/null
	#fi
fi
#/usr/sbin/SnareInstaller.sh -i %{buildroot}/etc %{buildroot}/usr/sbin %{buildroot}/usr/share/%{name}-%{version}
/usr/sbin/SnareInstaller.sh -i /etc /usr/sbin /usr/share/%{name}-%{version}
echo "Please modify /etc/snare.conf to turn on the web control interface"
/usr/sbin/SnareTranslationTable

%clean
if [ ! %{buildroot} = "/" ]; then %{__rm} -rf %{buildroot}; fi

%preun
# only if this is not an upgrade
if [ $1 -eq 0 ]; then
	#/etc/init.d/auditd stop && echo "auditd stopped, restoring auditd.conf"
	#/usr/sbin/SnareInstaller.sh -u %{buildroot}/etc %{buildroot}/usr/sbin %{buildroot}/usr/share/%{name}-%{version}
	/usr/sbin/SnareInstaller.sh -u /etc /usr/sbin /usr/share/%{name}-%{version}
fi

%postun
# only if this is not an upgrade
if [ $1 -eq 0 ]; then
	if [ -f /usr/sbin/semodule ]; then
		/usr/sbin/semodule -l | egrep "^snare" > /dev/null
		if [ "$?" -eq 0 ]; then
			/usr/sbin/semodule -r snare;
		fi
	fi
fi
#/etc/init.d/auditd start

%files
%defattr(-,root,root)
%attr(750,root,root) /usr/sbin/SnareDispatcher
%attr(750,root,root) /usr/sbin/SnareDispatchHelper
%attr(750,root,root) /usr/sbin/SnareTranslationTable
%attr(750,root,root) /usr/sbin/SnareWebServer.pl
%attr(750,root,root) /usr/sbin/SnareInstaller.sh
%attr(640,root,root) /etc/snare.conf
%attr(644,root,root) /usr/share/%{name}-%{version}/snare.pp
#%attr(644,root,root) /usr/share/%{name}-%{version}/snare2.pp
%config(noreplace) /etc/snare.conf

%changelog
* Wed Aug 15 2012 George Cora
- Bug fixes for the remote control page
- Allow Installer to use bash instead of sh
- Redefine gcc compilation order
- Do not overwrite existing snare.conf file if present during installation
- Include ability to view status in remote control page
- Use systemd for audit/snare restart/stop/start, if available
- Bug fixes in defining audit settings
- Bug fix to identify correct syscall architecture in auditctl (Thanks to Wayne Haig for this item)
- Include a README file

* Tue Aug 8 2011 David Mohr
- Updated micro web server authentication (digest)
- Added html entity stripping to the /events web page to prevent XSS
- Removed MD5 string from /remote web page
- Added cookie support for Change Tokens
- Added POST support to micro web server
- Added pre-submit MD5 hashing of remote access password in /remote web page
- Extended Change Token timeout
- Updated auditctl commands to support updated "-i" flag
- Updated SELinux policy module
- Thanks to Andrew Brooks, of Halock Security Labs for identifying items 2, 3 and 4

* Tue Jul 5 2011 David Mohr
- Bug fix for authentication event collection
- Update SELinux policy module

* Sat Dec 18 2010 David Mohr
- Updated architecture identification and syscall handling
- Added ability to pass objective filters directly to auditctl

* Mon Jun 28 2010 David Mohr
- Updated file permissions
- Minor Remote Control Interface updates
- Minor configuration checking updates
- Security patch to prevent Cross Site Request Forgery

* Wed Dec 17 2008 David Mohr
- Streamlined Helper/Dispatcher comms, minor resource saving
- Removed unnecessary regex from Dispatcher, major resource saving
- Made all file handles hot (no buffering)
- Improved signal handling between Helper and Dispatcher
- Fixed potential data corruption in DispatchHelper

* Fri Oct 24 2008 David Mohr
- Completely revised file watch configuration
- Fixed "empty fqdn/criticality" problem
- Improved authentication event handling
- Fixed "remove objective" bug that would delete two objectives
- Fixed message buffering in SnareDispatchHelper
- Fixed Display Recent Events rendering when using syslog
- Final RHEL4 targeted release

* Wed May 28 2008 David Mohr
- Further improved resource handling and collection speed (SnareDispatchHelper)
- Added support for file watches
- Updated compliance objective templates
- Improved objective handling including ability to drop events

* Mon Dec 3 2007 David Mohr
- Added support for login/logout events
- Added support for account modification events
- Improved resource handling and collection speed (SnareDispatchHelper)

* Mon Aug 7 2007 David Mohr
- Added support for compound matching elements (e.g. name=/etc/* name!=/etc/blah/*)
- Improved authentication support for remote control interface
- Updated SELinux policy (RHEL5 support)
- Improved automatic audit configuration using objective returncode detection to pre filter unnecessary records
- Fixed element matching error
- Fixed error in criticality reporting (e.g. criticality was always zero)
- Fixed race condition that could potentially clear all audit rules on restart
- Improved effeciency allowing a higher throughput
- Improved installer for easier deployment

* Mon Jul 2 2007 David Mohr
- Fixed syslog output
- Added file output support to web interface
- Fixed "Other" objective type to allow underscores
- Fixed exclusion lists
- Changed wildcards to match zero or more characters
- Added regex option to config file
- Added better Audit version detection
- DNS timeout for restricted access hosts

* Wed Nov 29 2006 Leigh Purdie
- Initial release - InterSect Alliance - http://www.intersectalliance.com/
