//
// Snare Audit Dispatcher for Linux - translation table creator
// (c) Copyright 2010 InterSect Alliance Pty Ltd
//
// Compile with gcc -laudit


#include <stdio.h>
#include <unistd.h>

extern const char *audit_syscall_to_name(int sc, int machine);
extern int audit_detect_machine(void);

int main()
{
	FILE * fp;
	int machine;
	const char *rsyscall;
	int i;

	machine=audit_detect_machine();
	//printf("MACHINE: [%d]\n",machine);

	unlink("/etc/snare-xlate.conf");
	unlink("/etc/snare-xlate32.conf");
	if (machine != 0) {
		fp=fopen("/etc/snare-xlate.conf","w");
		if(!fp) {
			perror("Cannot write to snare-xlate.conf");
			return(1);
		}

		for(i=0;i<2048;i++) {
			rsyscall=audit_syscall_to_name(i,machine);
			if(rsyscall) {
				fprintf(fp,"%i:%s\n",i,rsyscall);
			}
		}
		fclose(fp);
	}
	
	//Grab a list of 32bit X86 syscalls as well
	if (machine == 1 || machine == 0) {
		fp=fopen("/etc/snare-xlate32.conf","w");
		if(!fp) {
			perror("Cannot write to snare-xlate32.conf");
			return(1);
		}
		for(i=0;i<2048;i++) {
			rsyscall=audit_syscall_to_name(i,0);
			if(rsyscall) {
				fprintf(fp,"%i:%s\n",i,rsyscall);
			}
		}
		fclose(fp);
	}
	return(0);
}
